package com.capitalware.ufm.action.handlers;

import java.util.ArrayList;
import java.util.Hashtable;

import com.capitalware.ufm.UFM;
import com.capitalware.ufm.action.objects.UFMObject;
import com.capitalware.ufm.handlers.InternalMessageQueue;
import com.capitalware.ufm.watch.Watch;

/**
 * This class is used to handle the processing of actions in a separate thread.
 * This class is instantiated by TimerListener class.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class WorkerThreadForPA extends Thread
{
   public  ArrayList<UFMObject>         actionAL = null;
   private Hashtable<String,String>    properties = null;
   private Watch                       watchClass = null;
   private InternalMessageQueue                iq = null;

   /**
    * The constructor
    * @param actionAL
    * @param properties
    * @param iq
    */
   public WorkerThreadForPA(ArrayList<UFMObject> actionAL, Hashtable<String,String> properties, InternalMessageQueue  iq)
   {
      super();
      this.actionAL = actionAL;
      this.properties = properties;
      this.iq = iq;
   }

   /**
    * The constructor
    * @param actionAL
    * @param properties
    * @param watchClass
    * @param iq
    */
   public WorkerThreadForPA(ArrayList<UFMObject> actionAL, Hashtable<String,String> properties, Watch watchClass, InternalMessageQueue  iq)
   {
      super();
      this.actionAL = actionAL;
      this.properties = properties;
      this.watchClass = watchClass;
      this.iq = iq;
   }

   /**
    * Run (start) this puppy.
    */
   public void run()
   {
      UFM.logger.debug("WorkerThreadForPA starting.");

      ProcessActions pa = new ProcessActions(iq);
      if (watchClass != null)
         pa.setWatchClass(watchClass);
      pa.doWork(actionAL, properties);
   }
}
