package com.capitalware.ufm.actions;

import com.capitalware.ufm.UFM;
import com.capitalware.ufm.action.objects.LaunchObject;
import com.capitalware.ufm.objects.CWConstants;

/**
 * This class will handle executing an action command.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class LaunchAction extends UFMAction
{
   private LaunchObject   lo;

   /**
    * The constructor
    * @param lo
    */
   public LaunchAction(LaunchObject lo)
   {
      super(lo.actionName);
      this.lo = lo;
   }

   /**
    * Perform the work.
    * @return exitCode
    */
   public int doWork()
   {
      int exitCode = 0;
      lo.printValues();

      UFM.logger.info("Launch Action is starting: " + lo.xmlFile);
      UFM fm = new UFM();
      fm.setXmlFilename(lo.xmlFile);
      exitCode = fm.doWork(CWConstants.ONE_PASS, false);
      
      if (!lo.onErrorFail)
         exitCode = 0; /* reset back to zero */

      return exitCode;
   }
}
