package com.capitalware.ufm.ftp.objects;

import java.util.ArrayList;
import java.util.Hashtable;

import com.capitalware.ufm.UFM;
import com.capitalware.ufm.handlers.Tokens;
import com.capitalware.ufm.objects.CWConstants;

public class MkDirObject extends FtpCmdObject
{
   public String  remoteDir = null;

   /**
    * The constructor
    */
   public MkDirObject()
   {
      super();
   }

   /**
    * Verify the values in the object.
    */
   public void checkObject()
   {
      if (remoteDir == null)
         throw new IllegalArgumentException("Error: You must specify a TargetDirectory for the ftp MkDir command.");
   }
   
   /**
    * Process tokens in ftp Object's variables
    */
   public void performTokenization(Hashtable<String,String>  properties)
   {
      if (remoteDir != null)
         remoteDir = Tokens.replace(remoteDir, properties);
   }

   /**
    * Output the info
    * @param logger
    */
   public void printValues()
   {
      UFM.logger.info("         Target Directory = " + remoteDir);
   }

   /**
    * Convert the object to a string.
    * @return s
    */
   public ArrayList<String> toStringArray()
   {
      ArrayList<String> al = new ArrayList<String>();

      al.add("<"+CWConstants.FTP_MKDIR_ELEMENT+" "+CWConstants.REMOTE_DIR_ATTRIBUTE+"=\""+remoteDir+"\" />"+LINE_SEPARATOR);

      return al;
   }
}
