package com.capitalware.ufm.ftp.objects;

import java.util.ArrayList;
import java.util.Hashtable;

import com.capitalware.ufm.UFM;
import com.capitalware.ufm.objects.CWConstants;

public class TypeObject extends FtpCmdObject
{
   public char    mode = CWConstants.FTP_MODE_BINARY;

   /**
    * The constructor
    */
   public TypeObject()
   {
      super();
   }

   /**
    * Verify the values in the object.
    */
   public void checkObject()
   {
      if ( (mode != CWConstants.FTP_MODE_ASCII) && (mode != CWConstants.FTP_MODE_BINARY) )
         throw new IllegalArgumentException("Error: You must specify a valid value for the ftp mode command.");
   }
   
   /**
    * Process tokens in ftp Object's variables
    */
   public void performTokenization(Hashtable<String,String>  properties)
   {
   }

   /**
    * Output the info
    * @param logger
    */
   public void printValues()
   {
      UFM.logger.info("         Mode             = " + (mode == CWConstants.FTP_MODE_BINARY?"Binary":"ASCII"));
   }

   /**
    * Convert the object to a string.
    * @return s
    */
   public ArrayList<String> toStringArray()
   {
      ArrayList<String> al = new ArrayList<String>();

      al.add("<"+CWConstants.FTP_TYPE_ELEMENT+" "+CWConstants.MODE_ATTRIBUTE+"=\""+mode+"\" />"+LINE_SEPARATOR);

      return al;
   }
}
